/*The code was written and debugged by John C. Martin at the University of
  Minnesota (copyright 2004,2005).  You are free to distribute this source
  as long as this notice remains in tact.  End users of this code agree to
  take responsibility for how this code is used and John C. Martin and the
  University of Minnesota bear no liability.*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

float median(float *a,int n)
{
  int i,j,nl,d;
  float cl;
 
  nl=0;
  i=-1;
  d=n;
  while (nl!=(int)(n/2))
    {
      i++;
      nl=0;
      for (j=0;j<n;j++) if (a[j]>a[i]) nl++;
      if (i>=n-1) nl=(int)(n/2);
      if (abs(n/2-nl)<d) {d=abs(n/2-nl);cl=a[i];}
    }
 
  return(cl);
}
 
void MakeXcut(double **apix,long naxes[3],int r1,int r2,int c1,int c2,
              double *cutout)
{
  int i,j;
  float a[naxes[0]];
 
  if ((r2<r1)||(c2<c1)||(r1-1<0)||(r2-1>naxes[1])||(c1-1<0)||(c2-1>naxes[0])) {
    fprintf(stderr,"ERROR:  Bad Parameters for MakeXcut!\n");
  } else {
    for (i=r1-1;i<r2;i++) {
      for (j=c1-1;j<c2;j++) {a[j-c1+1]=apix[i][j];}
      cutout[i-r1+1]=median(a,c2-c1+1);
    }
  }
} 
